/*
  HACKO_beta_V_0.1, TempeHum,RTC,Telegram bot,Led light
  need to be implemented: ECsensor,Sleepmode,send a single message with all the info

  Created by Andrea Somenzi and Federico Denni.
  Released into the public domain.
  Powered by Polifactory
*/
//include libraries 
#include <Wire.h>
#include <RTClib.h>
#include "DFRobot_SHT20.h"
#include <Adafruit_NeoPixel.h>
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>

const int butpin = D8; //const pin button
const int ledpin = D6; //const pin Led

// Wifi network station credentials
#define WIFI_SSID "YOUR_SSID" //insert your wifi SSID
#define WIFI_PASSWORD "YOUR_PASSWORD"//insert your wifi password
// Telegram BOT Token (Get from Botfather)
#define BOT_TOKEN "XXXXXXXXX:XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"//insert your Telegram bot token
/* Use @myidbot to find out the chat ID of an individual or a group
Also note that you need to click "start" on a bot before it can message you*/
#define CHAT_ID "XXXXXXXXXX"//insert your Telegram chat ID

const unsigned long BOT_MTBS = 1000; // mean time between scan messages

X509List cert(TELEGRAM_CERTIFICATE_ROOT);
WiFiClientSecure secured_client;
UniversalTelegramBot bot(BOT_TOKEN, secured_client);
unsigned long bot_lasttime; // last time messages' scan has been done

DFRobot_SHT20    sht20;
RTC_DS3231 rtc; 
Adafruit_NeoPixel strip_a (1, ledpin); 

const int m = 6;//measurement stored values for sensors
float sensorvt[m];//stored values for temperature
float sensorvh[m];//stored values for humidity
// float sensorvec[m];// valori dei sensori 
float somma[4];// sum for sensor values 0temp, 1humid, 2ec, 4led color
float media[3];// average values for sensors 0temp, 1humid, 2ec
int valore[3];// value from confront medium and range values ranges 0temp, 1humid, 2ec
int minmaxTHEC[6] = {20,25,59,63,0,0};//range values min max 0tempmin,1tempmax,2hummin,3hummax,4ecmin,5ecmax
int n=0;// measurement number
int led;//led color

void setup() {
Serial.begin(9600);
 // attempt to connect to Wifi network:
  configTime(0, 0, "pool.ntp.org");      // get UTC time via NTP
  secured_client.setTrustAnchors(&cert); // Add root certificate for api.telegram.org
  Serial.print("Connecting to Wifi SSID ");
  Serial.print(WIFI_SSID);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);
  while (WiFi.status() != WL_CONNECTED)
  {
    Serial.print(".");
    delay(500);
  }
  Serial.print("\nWiFi connected. IP address: ");
  Serial.println(WiFi.localIP());

  // Check NTP/Time, usually it is instantaneous and you can delete the code below.
  Serial.print("Retrieving time: ");
  time_t now = time(nullptr);
  while (now < 24 * 3600)
  {
    Serial.print(".");
    delay(100);
    now = time(nullptr);
  }
  Serial.println(now);
//send starting message
{bot.sendMessage(CHAT_ID, "Ciao, i'm Hacko, your nukazuke fermentation assistant and expert, i'll keep you updated about how your nukazuke fermentation is going");}//staring bot message
//pin button and led
strip_a.begin();
strip_a.show();
pinMode (ledpin, OUTPUT);
pinMode (butpin, INPUT);
digitalWrite (ledpin, LOW);
digitalWrite  (butpin, LOW);
//rtc
if(!rtc.begin()) {
        Serial.println("Couldn't find RTC!");
        while(true);
    }
     rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));  
  if(rtc.lostPower()) {
       // this will adjust to the date and time at compilation
       rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
   } 
   rtc.disable32K();
   rtc.disableAlarm(2);
   rtc.clearAlarm(1);
   rtc.clearAlarm(2);
   rtc.writeSqwPinMode(DS3231_OFF);

  if(!rtc.setAlarm1(
            rtc.now(),
            DS3231_A1_Minute // this mode triggers the alarm when the minutes match every hour. See Doxygen for other options
  )) {
        Serial.println("Error, alarm wasn't set!");
  }else {
        Serial.println("Alarm set");  
  }
//SHT Sensor 
sht20.initSHT20();                                  // Init SHT20 Sensor
delay(100);
sht20.checkSHT20();                                 // Check SHT20 Sensor
}
void loop() {
DateTime now = rtc.now(); //read time
DateTime inizio = DateTime(F(__DATE__), F(__TIME__));//create starting date
DateTime verde (inizio + TimeSpan(0,21,0,0)); //set the pickling time 21 days after starting date
int butstate;
butstate = digitalRead(butpin);//read butpin
if (butstate == HIGH){
 if(led == 0){
   if(now >= verde) {strip_a.setPixelColor(0, 0, 100, 0);}//if 20 days are passed from start white light turn green
   else (strip_a.setPixelColor(0, 100, 100, 100));}
 else{strip_a.setPixelColor(0, 100, 0, 0);}}
else { strip_a.setPixelColor(0, 0, 0, 0);}
 strip_a.show();
 
if(rtc.alarmFired(1)) {//if alarm fired start measuration
   
  sensorvt[n] = sht20.readTemperature(); // Read Temperature
  sensorvh[n] = sht20.readHumidity(); // Read Humidity
  //sensorvec[n] = sht20.readTemperature(); // Read EC
  
  delay(100);
  // if valore temp hum e ec gives error stop, otherwise continue
  if ( sensorvt[n] == 0 || sensorvt[n] >= 900 ){Serial.println("ERROR");delay(5000);}
  else if ( sensorvh[n] == 0 || sensorvh[n] >= 900 ){Serial.println("ERROR");delay(5000);} 
  else {
    if ( sensorvt[5] != 0) { //if last measurement value is different from zero do the average value for all the measurement values for temperature
     for(int i = 0; i < m; i++) {
     somma[0] =  somma[0] + sensorvt[i];}
     media[0] = somma[0]/ m;
     if( media[0] < minmaxTHEC[0]) //if average temp is to low set the value to 1
      {valore[0] = 1;}
     else if (media[0] > minmaxTHEC[1]) 
     {valore[0] = 2;} //if average temp is to low set the value to 2
     else {valore[0] = 0;}} //if average temp is in the right range set the value to 0
   else {// if not all the measurement are done check if the value is inbetween the range
     if(sensorvt[n] < minmaxTHEC[0]) //if temp is to low set the value to 1
     {valore[0] = 1;}
     else if (sensorvt[n] > minmaxTHEC[1]) //if temp is to low set the value to 2
      {valore[0] = 2;}
     else {valore[0] = 0;};}//if temp is to low set the value to 1

    if ( sensorvh[5] != 0) { //if last measurement value is different from zero do the average value for all the measurement values for humidity
     for(int i = 0; i < m; i++) {
     somma[1] =  somma[1] + sensorvh[i];}
     media[1] = somma[1]/ m;
     if( media[1] < minmaxTHEC[2]) //if average hum is to low set the value to 1
      {valore[1] = 1;}
     else if (media[1] > minmaxTHEC[3]) 
     {valore[1] = 2;} //if average hum  is to low set the value to 2
     else {valore[1] = 0;}} //if average hum  is in the right range set the value to 0
   else {// if not all the measurement are done check if the value is inbetween the range
     if(sensorvh[n] < minmaxTHEC[2]) //if hum is to low set the value to 1
     {valore[1] = 1;}
     else if (sensorvh[n] > minmaxTHEC[3]) //if hum is to low set the value to 2
      {valore[1] = 2;}
     else {valore[1] = 0;};}//if hum is to low set the value to 1

   for(int i = 0; i < 3; i++ ){//sum all the values from temp,hum,ec
   {somma[3] = somma[3] + valore[i];
   Serial.print("somma 3: "); Serial.println( somma[3]);
   Serial.print("valore: "); Serial.println(valore[i]);}}// calcola la somma di tutti i valori dell'array 
   if (somma[3] == 0) { led = 0;}
   else { led = 1;} //set led value
    
   if (n==5) {n=0;//overwrite the first value next measurement if n=5
    String temp = String(media[0]);
    String hum = String(media[1]);
    //String ec = String(media[2]);

    if (valore[0] == 1){bot.sendMessage(CHAT_ID, "Your nuka temperature is:" + temp + ", it's too cold! To increase the temperature put your nukazuke in a warmer place or cover it with a blanket but watch out to let it breath. The best temperature range for nuka fermentation is between 20 - 25°C, lower the temperature lower will be the fermentation speed");}
    else if (valore[0] == 2){bot.sendMessage(CHAT_ID, "Your nuka temperature is:" + temp + ", it's too hot! To decrease the temperature put your nukazuke in a cool and dark place. The best temperature range for nuka fermentation is between 20 - 25°C, also and it should not be put in the direct sunlight");}
    else {bot.sendMessage(CHAT_ID, "Your nuka temperature is:" + temp + ", it's perfect! The best temperature range for nuka fermentation is between 20 - 25°C");}

    if (valore[1] == 1){bot.sendMessage(CHAT_ID, "Your nuka humidity is:" + hum  + ", it's too dry! To increase the water amount you can add some vegetables. The best humidity range for nuka fermentation is between 59 - 63%");}
    else if (valore[1] == 2){bot.sendMessage(CHAT_ID, "Your nuka humidity  is:" + hum  + ", it's too soggy! To decrease the water amount stop putting vegetables inside for a few days, watch out for the salt level too. The best humidity range for nuka fermentation is between 59 - 63%");}
    else {bot.sendMessage(CHAT_ID, "Your nuka humidity is:" + temp + ", it's perfect! The best humidity range for nuka fermentation is between 59 - 63%");}
   }
   else {n=n+1;}// increase the measurement counter

   somma[0] = 0;//reset the starting value for next average temperature calculation
   //somma[1] = 0;//reset the starting value for next average humidity calculation 
   //somma[2] = 0;//reset the starting value for next average ec calculation
   somma[3] = 0; //reset the average value for next 

   rtc.clearAlarm(1);//reset alarm
 delay(100);
  }
 }
}



